"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _injectscript = require("./utils/injectscript");

var _proptypes = require("./proptypes");

var _preventGoogleFonts = require("./utils/prevent-google-fonts");

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var LoadScript =
/*#__PURE__*/
function (_Component) {
  _inherits(LoadScript, _Component);

  function LoadScript() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, LoadScript);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(LoadScript)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      loaded: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "componentDidMount", function () {
      var _this$props = _this.props,
          id = _this$props.id,
          googleMapsApiKey = _this$props.googleMapsApiKey,
          language = _this$props.language,
          region = _this$props.region,
          version = _this$props.version,
          libraries = _this$props.libraries,
          preventGoogleFontsLoading = _this$props.preventGoogleFontsLoading;

      if (preventGoogleFontsLoading) {
        (0, _preventGoogleFonts.preventGoogleFonts)();
      }

      (0, _injectscript.injectScript)({
        id: id,
        url: "https://maps.googleapis.com/maps/api/js?v=".concat(version, "&key=").concat(googleMapsApiKey, "&language=").concat(language, "&region=").concat(region).concat(libraries ? "&libraries=".concat(libraries.join(',')) : ''),
        onSuccess: function onSuccess() {
          _this.props.onLoad();

          _this.setState(function () {
            return {
              loaded: true
            };
          });
        },
        onError: function onError() {
          throw new Error("\nThere has been an Error with loading Google Maps API script, please check that you provided all required props to <LoadScript />\nProps you have provided:\n\ngoogleMapsApiKey: ".concat(_this.props.googleMapsApiKey, "\nlanguage: ").concat(_this.props.language, "\nregion: ").concat(_this.props.region, "\nversion: ").concat(_this.props.version, "\nlibraries: ").concat((_this.props.libraries || []).join(','), "\n\nOtherwise it is a Network issues.\n"));
        }
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "componentWillUnmount", function () {
      var script = document.getElementById(_this.props.id);
      script.parentNode.removeChild(script);
      Array.prototype.slice.call(document.getElementsByTagName('script')).filter(function (script) {
        return script.src.includes('maps.googleapis');
      }).forEach(function (script) {
        script.parentNode.removeChild(script);
      });
      Array.prototype.slice.call(document.getElementsByTagName('link')).filter(function (link) {
        return link.href === 'https://fonts.googleapis.com/css?family=Roboto:300,400,500,700|Google+Sans';
      }).forEach(function (link) {
        link.parentNode.removeChild(link);
      });
      Array.prototype.slice.call(document.getElementsByTagName('style')).filter(function (style) {
        return style.innerText.includes('.gm-');
      }).forEach(function (style) {
        style.parentNode.removeChild(style);
      });
      delete window.google.maps.version;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      return _this.state.loaded ? _this.props.children : _this.props.loadingElement;
    });

    return _this;
  }

  return LoadScript;
}(_react.Component);

_defineProperty(LoadScript, "defaultProps", {
  onLoad: function onLoad() {},
  onError: function onError() {}
});

var _default = LoadScript;
exports.default = _default;