"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.injectScript = void 0;

var injectScript = function injectScript(_ref) {
  var url = _ref.url,
      id = _ref.id,
      onSuccess = _ref.onSuccess,
      onError = _ref.onError;

  if (typeof document !== 'undefined') {
    return new Promise(function (resolve, reject) {
      var prevScript = document.getElementById(id);

      if (!prevScript) {
        var script = document.createElement('script');
        script.type = 'text/javascript';
        script.src = url;
        script.id = id;
        script.async = true;

        script.onload = function () {
          resolve(onSuccess());
        };

        script.onerror = function (e) {
          reject(onError(e));
        };

        document.head.appendChild(script);
      } else {
        resolve(onSuccess());
      }
    });
  } else {
    onError();
  }
};

exports.injectScript = injectScript;